import {_boolean, _object, __ as cls, popUpInstances, bs, _string, _primitive, isElement} from "../utils/lib.js";

export default function(_, message, props) {
    const __ = (className, tagName)=> cls.call(_, className, tagName);
    let header = 'Confirm';
    let buttons = [
        { id: 0, value: 'No' },
        { id: 1, value: 'Yes' }
    ]

    const { buttons: bt, title: tt } = props;
    header = tt;
    if (Array.isArray(bt) && bt.every(b => _primitive(b.id, null) && (isElement(b.value) || _string(b.value, null))))
        buttons = bt;

    buttons = buttons.map(b => {
        let { value, id } = b;
        let _b = __(bs.btn, 'button').addChild(value);
        if (typeof value === 'object')
            _b = _.isJQL(value) ? value : _(value);
        return _b.attr({ 'data-response': id });
    });

    let mod = _.modal(message, {
        header,
        innerScroll: false,
        footer: buttons,
        backdrop: 'static'
    });
    return new Promise((res, rej) => {
        mod.on('hidden', () => {
            popUpInstances.shift().drop();
            if (popUpInstances.length > 0)
                popUpInstances[0].show();
            rej();
        });
        buttons.forEach(bt => {
            bt.on('click', () => {
                let resp = bt.attr('data-response');
                if (resp === '0')
                    rej();
                else
                    res(resp)
                mod.hide();
            })
        })
        if (popUpInstances.length == 0)
            mod.show();
        popUpInstances.push(mod);
    })
}