import {_boolean, __ as cls, bs, popUpInstances, _string} from "../utils/lib.js";

export default function(_, message, props) {
    const __ = (className, tagName)=> cls.call(_, className, tagName);
    let {type, okText: ot, cancelText: ct, initial: ini } = props;
    type = ['color', 'date', 'datetime-local', 'email', 'file', 'month', 'number', 'password', 'range', 'tel', 'text', 'time', 'url', 'week'].includes(type) ? type : 'text';
    let inp = __('form-control shadow-none border-none', 'input').attr({ type });
    inp.style({
        marginBottom: '-17px',
        border: 'none',
        borderRadius: '0',
        borderBottom: '1px solid #ced4da'
    }).value(ini && ini || '');

    let body = [_('<h5/>').addChild(_string(message)), inp];
    let done = __(bs.btn, 'button').addChild('Done');
    let cancel = __(bs.btn, 'button').addChild('Cancel');
    if (typeof ot === 'string')
        done.refill(ot);
    else if (typeof ot === 'object')
        done = ot;
    if (typeof ct === 'string')
        cancel.refill(ct);
    else if (typeof ct === 'object')
        cancel = ct;

    let mod = _.modal(body, {
        innerScroll: false,
        footer: [cancel, done]
    });

    return new Promise((res, rej) => {
        mod.on('hidden', () => {
            popUpInstances.shift().drop();
            if (popUpInstances.length > 0)
                popUpInstances[0].show();
            rej();
        });
        mod.on('shown', () => {
            inp.focus();
            inp.select();
        });
        cancel.on('click', mod.hide);
        done.on('click', () => {
            res(type === 'file'? [].slice.call(inp.plain(0).files) : inp.value());
            mod.hide();
        })
        if (popUpInstances.length == 0)
            mod.show();
        popUpInstances.push(mod);
    })
}