import {_boolean, __ as cls, bs} from "../utils/lib.js";
import Carousel from "./carousel.js";

export default (_, slides, {
    footer,
    alignHeader: ah,
    alignFooter: af,
    breakHead: bh,
    breakFoot: bf,
    speed,
    touch
}) => {
    const __ = (className, tagName)=> cls.call(_, className, tagName);
    let forCarousel = [];
    if (!Array.isArray(slides) || slides.length === 0) throw new Error('Invalid slides property');
    slides.forEach(slide => forCarousel.push(slide.body));

    ah = typeof ah === 'string' && ['left', 'right'].includes(ah) ? ah : 'center';
    af = typeof af === 'string' && ['left', 'right'].includes(af) ? af : 'center';
    bh = _boolean(bh, false) ? 'normal' : 'nowrap';
    bf = _boolean(bf, false) ? 'normal' : 'nowrap';

    const car = Carousel(_, forCarousel, {
        arrows: false,
        indicators: false,
        interval: false,
        autostart: false,
        touch,
        hover: true,
        keyboard: false,
        speed
    });
    let headers = [];
    let card;
    slides.forEach((slide, index) => {
        let _btn = __([bs.btn, 'me-1'], 'button')
            .on('click', () => {
                car.to(index);
            })
            .addChild(slide.title);
        (index === 0) && _btn.addClass('btn-secondary');

        headers.push(_btn)
    });
    car.on('slide', e => {
        let frm = e.from,
            to = e.to;
        let res = 100 * e.to;
        headers[frm].removeClass('btn-secondary');
        headers[to].addClass('btn-secondary');
        headers[frm].parent().scrollTo({
            left: to > frm ? res : -res,
            behavior: 'smooth'
        });

        [slides[e.from].onHide, slides[e.to].onShow]
        .forEach(cb => typeof cb === 'function' && cb({ from: headers[frm], to: headers[to] }))
    })
    card = _.card(car.container, {
        header: headers,
        footer
    });
    let ch = card.children();
    ch.get(0).style({ overflowX: 'auto', whiteSpace: bh, textAlign: ah });
    ch.get(1).style({ padding: '0', height: `0` })
    card.style({ height: '100%', whiteSpace: bf, textAlign: af });
    return card;
}