import {states, isJQL, _array} from "../../utils/lib.js";
import handleMove from "./move.js";

export default (_, { el, e, height, width, movable, fixed, relativeTo: rt, onMove, onMoving, onMoved }) => {
    if(_array(e.path).includes(el)) return;
    el = _(el).addClass('mini-scrollbar');
    let x, y, _x, _y, to;
    fixed = typeof fixed === 'boolean' ? fixed : true;

    if (fixed) {
        el.style({ position: 'fixed' });
    }
    height = height || el.offsetHeight();
    width = width || el.offsetWidth();
    el.style({
        height: height + 'px',
        width: width + 'px',
        zIndex: ++states.zIindex,
        left: 'unset',
        right: 'unset',
        bottom: 'unset',
        top: 'unset'
    });

    if (!rt) {
        to = _(document.body).style({ position: 'relative' });
        x = e.x;
        y = e.y;
        _y = innerHeight - y;
        _x = innerWidth - x;

        el.style({ top: y + 'px' });
        if (_y < height)
            el.style({ top: (y - (height - _y) - 20) + 'px' });

        el.style({ left: x + 'px' });
        if (_x < width)
            el.style({ left: x - (width - _x) - 20 + 'px' });
    } else {

        let path = e.path;
        to = isJQL(rt) ? rt.plain() : typeof rt === 'object' && rt.tagName ? rt : null;
        to = to && path.includes(to) ? to : path.find(p => p.scrollHeight > p.clientHeight && p.tagName != 'HTML');
        to = to ? _(to) : _(document.body);


        let bc = to.getBoundingClientRect();

        let distY = (e.y + to.scrollTop() - bc.top);
        let distX = (e.x + to.scrollLeft() - bc.left);

        if (distY + height > to.scrollHeight())
            distY = to.scrollHeight() - height - 10;

        if (distX + width > to.scrollWidth())
            distX = to.scrollWidth() - width - 5;

        to = to.style({ position: 'relative' });
        el.style({ position: 'absolute', top: distY + 'px' });
        el.style({ left: distX + 'px' });
    }
    el.appendTo(to);
    if (movable) {
        let movepoint = el;
        if (isJQL(movable))
            movepoint = movable;
        if (typeof movable === 'object' && movable.tagName)
            movepoint = _(movable);

        handleMove(_, { el: el.plain(), movepoint, onMove, onMoving, onMoved })
    }

    return el;
}